/*
#################    Regulator Poziomu Umysu    ############################
###################    (C) Piotr Wjtowicz    ###############################
################   Wlka Bodzechowska, + kwiecie 2005 +    #################
*/

#include <signal.h>
#include <io.h>
#include <interrupt.h>
#include "SIN.h"
#include "FTABLE.h"
#include "LED.h"


const int min_f=0;
const int max_f=49;
const char  LD=0xfe; //lewy display LED
const char RD=0xfd; //prawy spisplay LED
const short int SIN_n=256;
const short int SIN_max=625*50;

unsigned short int SIN_i; //licznik przerwan t0 dla uzytku generatora sinusa
unsigned char SIN_f;//
unsigned char LED_i; //licznik tez przerwan t0 ale dla uzytku wyswietlacza
unsigned char f_LED;
char f0; //wartosc sinusa odniesienia
int f;
unsigned char fn=2; //czestotliwosc nosna - fn=1 dla f=625Hz, fn=2 dla f=(625/2)Hz
			

//************************************************************************
void loop(long int n)
{
   long int i;
   for(i=0;i<n;i++);
};
//************************************************************************
SIGNAL (SIG_OVERFLOW1)
{
   unsigned char x1,x2,x3;
//omega t dla fn=1 i dla fn=2
   if (fn==2) { if (LED_i==1) SIN_i++; }
   else SIN_i++;
//:::::::::::::::sinus AUDIO
//przebieg odniesienia f0
   x1=(1310*SIN_i)>>8; //1310=ftable[0]
   OCR1A=SIN[x1];
//przebieg o czestotliwosci  rownej f0+f
   x2=(ftable[f]*SIN_i)>>8;
   OCR1B=SIN[x2];
//:::::::::::::::LED
   x3=x2-x1;
   OCR2=x3;
//:::::::::::::::wyswietlacz LED
   PORTD|=0xfb;
   PORTB|=0xc1;
   if (LED_i==1)
//jednosci liczby f
   {
      PORTB&=LED_jedn_PB[f_LED];
      PORTD&=LED_jedn_PD[f_LED];
   }    
   else
//dziesiatki liczby f
   {
      PORTB&=LED_dzies_PB[f_LED];
      PORTD&=LED_dzies_PD[f_LED];
      LED_i=0;
   };
   LED_i++;
};
//************************************************************************
//funkcja bada czy wcisniety jest przycisk UP
//jezeli jest wcisniety - zwraca 1
//jezeli nie - zwraca 0
inline unsigned char up(void) { return((~PIND & 0x20)>>5); };
//************************************************************************
//funkcja sprawdza czy wcisniety jest przycisk DOWN
//jezeli jest wcisniety - zwraca 1
//jezeli nie - zwraca 0
inline unsigned char down(void){ return((~PIND & 0x04)>>2); };
//************************************************************************
int main(void)
{
//ustawiam kierunek portow
   DDRB=0xff;
   DDRD=0xdb;
   //podciagam wejscia przyciskow
   PORTD|=0x24;
// t1 jako 8-bit fast PWM
   TCCR1A=0xf1;
// t1 bez preskalera
   TCCR1B=0x09;
   timer_enable_int (_BV (TOIE1));
// enable interrupts
   sei ();
//konfig t2
   TCCR2=0x69;
   
   int faza,licznik;
   unsigned char warunek;   
   
   for(;;)
   {
//czy wcisnieto 2 przyciski i czestotliwosc==0?
//jesli tak to nastepuje przelaczenie czestotliwosci "nonej"
	  if (up()==1 && down()==1 && f==0)
	  {
		 if (fn==1) fn=2;
		 else fn=1;
		 do { }
		 while (up()==1 || down()==1); //czekaj az zostana puszczone przyciski
		 loop(1000); //gaszenie drgan przyciskow
	  };
//zwieksz lub zmniejsz czestotliwosc
	  if (up()==1 || down()==1)
      {
		 SIN_i=0;
		 if (up()==1 && f/fn<max_f) f+=fn; //zwiekrzanie czestotliwosci
         if (down()==1 && f/fn>min_f) f-=fn; //zmniejszanie f
		 if (faza<3) licznik=2500; //opoznienie dla pierwszych 3 przeskokow
         else licznik=500; //opoznienie dla kolejnych przeskokow
		 do 
		 {
		    licznik--;
			warunek=up()+down();
		 }   
		 while (!(licznik==0 || warunek==0));//petelka opozniajaca przeskakiwanie
//cyferek na wyswietlaczu przy wcisnietym przycisku
		 faza++;
		 if(faza>4) faza=4;
		 loop(100); //gaszenie drgan przyciskow
      }
      else faza=0;
      f_LED=f/fn; //zeby wyswietlacz pokazywal wlasciwa czestotliwosc
   };

   return (0);
}
